from calendar import month_name
from fileinput import filename
from os import listdir
from os.path import join, dirname, realpath
from sqlalchemy import null
from werkzeug.utils import secure_filename
import os
from flask import Flask, request, Blueprint, jsonify, redirect, url_for,flash, render_template,session,json
import datetime
from datetime import timedelta,date,datetime
from flask import session, app
from .. import Cryptography,Auth,RouteGroup,Helper
from core.model.Users import Users
from core.model.Society import Society
from core.model.MMemberType import MMemberType
from core.model.CommitteeModel import CommitteeModel
from core.model.MembershipMailTemplates import MembershipMailTemplates
from core.library.email import EMAIL
import boto3, botocore
from botocore.exceptions import ClientError
import logging
from urllib.parse import unquote



app = Blueprint('committee', __name__)


@app.route('/Official_committees/<int:society_id>/<string:society_key>/at/<user_uuid>/<timestamp>', methods = ["GET", "POST"])
@RouteGroup.society_required
def Official_committees(society_id,society_key,user_uuid,timestamp):
	timestamp = round(int(timestamp[:-3]))
	timestamp = datetime.fromtimestamp(int(timestamp))
	if timestamp and (datetime.now() < timestamp):
		userData  = Users().get_autologin_data(user_uuid)
		user_id   = userData['user_id']
		if userData:
			Auth.checkSocietybyIdKey(society_id,society_key)
			bo_access = Users().check_bo_access(userData['email'],1,society_id,None)
			userData["is_admin"] =  bo_access["is_admin"]
			Auth.login(userData,society_id)
			return redirect(url_for("committee.CommitteeUser",user_uuid=user_uuid,society_id=society_id,society_key=society_key))
		else:
			return redirect("live.ksos.in")

	else:
		return redirect("live.ksos.in")


@app.route('/committee_user/<user_uuid>/<int:society_id>/<string:society_key>',methods = ["GET", "POST"])
@RouteGroup.login_required
def CommitteeUser(user_uuid,society_id,society_key):
	committee_members = CommitteeModel().get_committee_members(society_id)
	committee_detail=committee_members[0]
	committee_members_details = committee_members[1]
	return render_template('committee/committee_members.html',data=committee_detail,society_id=society_id,society_key=society_key,committee_members_details=committee_members_details,user_uuid=user_uuid)


@app.route('/committee_user_query/<user_uuid>/<int:society_id>/<string:society_key>/<committee_id>',methods = ["GET", "POST"])
@RouteGroup.login_required
def CommitteeUserQuery(user_uuid,society_id,society_key,committee_id):
	committee_members = CommitteeModel().get_committee_members(society_id)
	committee_detail=committee_members[0]
	committee_members_details = committee_members[1]
	return render_template('committee/committee_users_query.html',data=committee_detail,society_id=society_id,society_key=society_key,committee_members_details=committee_members_details,committee_id=committee_id,user_uuid=user_uuid)

@app.route('/post_committee_user_query/<user_uuid>/<int:society_id>/<string:society_key>/<committee_id>',methods = ["GET", "POST"])
@RouteGroup.login_required
def PostCommitteeUserQuery(user_uuid,society_id,society_key,committee_id):
	user        = Users().get_autologin_data(user_uuid)
	if user:
		user_id     = user['user_id']
		cc_email    = user['email']
		user_name   = user['prefix']+user['full_name'] if user['prefix'] else user['full_name']
	now   = datetime.now().strftime("%d-%m-%Y %I:%M %p")
	query_subject = request.values.get("subject")
	query   = request.values.get("query")
	societyData = Auth.checkSocietybyIdKey(society_id,society_key)
	from_mail_name = societyData['society_title']
	from_mail_id   = societyData['e_support_mail']
	reply_mail_id  = cc_email
	get_committee_name = CommitteeModel().get_committee_name(committee_id)
	committee_name = get_committee_name.committee_name
	particular_committee_id = CommitteeModel().get_particular_committee_id(society_id,committee_id)
	# priyavarthana@numerotec.com,sivabalan@numerotec.com
	to_email=[]
	str_to_email=""
	subject = "Query raised by " + user_name + " dated " + now + " / " +  committee_name
	if particular_committee_id:
		for i in  particular_committee_id:
			to_email.append(i['email'])
			str_to_email += str(i['email'])+','
	str_to_email = str_to_email.rstrip(',')
	data ={'committee_id':committee_id,'user_id':user_id, 'subject':query_subject, 'query':query, 'created_at':datetime.now(),'email_ids':str_to_email}
	CommitteeModel().insert_communication(data)
	html = render_template('committee/committee_email.html',societyData=societyData,subject=query_subject,query=query,now=now,user_name=user_name,str_to_email=str_to_email,cc_email=cc_email,committee_name=committee_name)
	# return html
	EMAIL.SendMailChangeTarrif(reply_mail_id,from_mail_id,from_mail_name,subject,html,to_email,cc_email)
	flash("Mail sent successfully","successMsg")
	return redirect(url_for('committee.CommitteeUser',user_uuid=user_uuid,society_id=society_id,society_key=society_key))


	