from flask import Flask, request, Blueprint, jsonify, redirect, url_for,flash, render_template,session,json
import datetime
from datetime import timedelta,date,datetime
from flask import session, app
from .. import Cryptography,Auth,RouteGroup,Helper
from core.model.Users import Users
from core.model.Reference import Reference
from core.model.ProSecReminderMailModel import ProSecReminderMailModel
from core.model.MembershipMailTemplates import MembershipMailTemplates
from core.model.Society import Society
from core.library.email import EMAIL

app = Blueprint('prosecreminder', __name__)


@app.route('/prosec_reminder_mail_v1',methods = ["GET", "POST"])
def ProSecRemainderMailV1():
	update_data = {}
	reminder_email_count = 0
	now 		 = datetime.now()
	dt_string    = now.strftime("%Y-%m-%d %H:%M:%S")
	hour         = now.hour
	minutes      = now.minute
# 	if minutes:
	if (hour == 9 and minutes > 45) or (hour == 10 and minutes < 23):
		pending_data  = ProSecReminderMailModel().usp_get_ps_pending_data(dt_string,None)
		if pending_data :
			for value in pending_data:
				society_id            = value['society_id']
				society_key           = value['society_key']
				reference_id          = value['reference_id']
				user_id 			  = value['user_id']
				user_uuid 			  = value['user_uuid']
				reference_uuid 		  = value['reference_uuid']
				reference_by          = value['reference_by']
				reference_type        = value['type']
				reminder_email_count  = value['reminder_email_count']
				reference_prefix      = value['reference_prefix']
				reference_name        = value['reference_name']
				reference_email       = value['reference_email']
				user_prefix           = value['user_prefix']
				user_name             = value['user_name']
				user_email            = value['user_email']
				next_reminder_date    = value['next_reminder_date']

				reference_full_name   = reference_prefix+" "+reference_name if reference_prefix else reference_name
				user_full_name        = user_prefix+" "+user_name if user_prefix else user_name
				societyData           = Society().getSociety(society_id,society_key)
				if reminder_email_count >= 3:
					pass
				else:
					if reminder_email_count :
						reminder_email_count = reminder_email_count+ 1
					else : 
						reminder_email_count = 0 +1
						
					if next_reminder_date :
						next_reminder_date = next_reminder_date +timedelta(days=3)
					else :
						next_reminder_date = now +timedelta(days=3)
						next_reminder_date = next_reminder_date.date()

					if reminder_email_count and reminder_email_count == 1 :
						data = {'reminder_email_count' : reminder_email_count,'reminder_one_sent_at' : now,'updated_at' : now,'next_reminder_date':next_reminder_date}
					elif reminder_email_count and reminder_email_count == 2 :
						data = {'reminder_email_count' : reminder_email_count,'reminder_two_sent_at' : now,'updated_at' : now,'next_reminder_date':next_reminder_date}
					else :
						data = {'reminder_email_count' : reminder_email_count,'reminder_three_sent_at' : now,'updated_at' : now,'next_reminder_date':next_reminder_date}

					ProSecReminderMailModel().update_reminder_data(data,reference_id) 
					reminderMailData = MembershipMailTemplates().get_mail_template(society_id,"autoreminder_prosec")
					sub_data        = {'full_name'    : user_full_name,'society_name' : societyData['society_intial'],'reminder_email_count':str(reminder_email_count)}
					subject         = Helper.merge_tags(reminderMailData.subject,sub_data)
					m_data          = {
						'mail_content'        : reminderMailData.mail_content,
						'reference_full_name' : reference_full_name,
						'user_full_name'	  : user_full_name,
						'reference_type'	  : reference_type,
						'user_uuid'           : user_uuid,
						'reference_uuid'      : reference_uuid,
						'societyData'		  : societyData
					}
					# reference_email  ="priyavarthana@numerotec.com"
					mail_content     = Helper.convert_html_for_mail_screen(m_data)
					# print(reference_email)
					html             = render_template('back_office/email/bo_mail_template.html',mail_content=mail_content,societyData=societyData,society_id=society_id,society_key=society_key)
					EMAIL.sendMail(subject,html,reference_email,reminderMailData,societyData)
					# return "success"	

			return 'success for sending Proposer and Seconder reminder mail'
		else:
			return "Pending data does not exist"
		
	else :
		return dt_string +  "- Time not match"
		
# after 3 days
@app.route('/autoreminder_mail_after_three_days_v1',methods = ["GET", "POST"])
def AfterThreeDaysV1():
	send_now    = request.values.get('send_now',None)
	date 		    = datetime.now() - timedelta(days=3)
	currentDate     = date.strftime("%Y-%m-%d")
	incompletedData = Users().get_reminder_incomplete_data(currentDate)
	template_name   = "autoreminder_three_days"
	return IncompleteRemainderMail(incompletedData,template_name,send_now)

@app.route('/autoreminder_mail_after_seven_days_v1',methods = ["GET", "POST"])
def AfterSevenDaysV1():
	send_now    = request.values.get('send_now',None)
	date 		    = datetime.now() - timedelta(days=7)
	currentDate     = date.strftime("%Y-%m-%d")
	incompletedData = Users().get_reminder_incomplete_data(currentDate)
	template_name   = "autoreminder_seven_days"
	return IncompleteRemainderMail(incompletedData,template_name,send_now)
	
@app.route('/payment_autoreminder_mail_after_seven_days',methods = ["GET", "POST"])
def paymentAfterSevenDays():
	send_now    = request.values.get('send_now',None)
	date 		    = datetime.now() - timedelta(days=7)
	currentDate     = date.strftime("%Y-%m-%d")
	incompletedData = Users().get__incomplete_payment_data_seven_days(currentDate)
	template_name   = "autoreminder_seven_days_payment"
	return IncompleteRemainderMail(incompletedData,template_name,send_now)	

@app.route('/delete_application_after_ten_days',methods = ["GET", "POST"])
def DeleteApplicationAfterTenDays():
	send_now    = request.values.get('send_now',None)
	date 		    = datetime.now() - timedelta(days=10)
	currentDate     = date.strftime("%Y-%m-%d")
	incompletedData = Users().get_incomplete_payment_data_ten_days(currentDate)
	template_name   = "delete_application_mail"
	return IncompleteRemainderMail(incompletedData,template_name,send_now)
	
	
def IncompleteRemainderMail(incompletedData,template_name,send_now):
	now 		 = datetime.now()
	currentTime  = now.strftime("%Y-%m-%d %H:%M:%S")
	hour         = now.hour
	minutes      = now.minute
	currentDate  = now.strftime("%Y-%m-%d")

	if incompletedData:
		
		for value in incompletedData:
			updated_at     = value['updated_at']
			user_prefix    = value['prefix']
			user_name      = value['full_name']
			user_uuid      = value['user_uuid']
			email          = value['email']
			user_full_name = user_prefix+" "+user_name if user_prefix else user_name
			society      = Society().getSociety(value['society_id'],value['society_key'])
			sub_data     = {'society_name' : society['society_intial']}
			if template_name == "autoreminder_seven_days_payment" :
				updated_at   = value['secretary_approved_on']
			if template_name == "delete_application_mail" :
				sub_data     = {'full_name'    : user_full_name,'society_name' : society['society_intial']}
				updated_at   = value['secretary_approved_on']
				Users().usp_delete_incomplete_payment_data(value['user_id'],value['society_id'],now)
			mailData     = MembershipMailTemplates().get_mail_template(value['society_id'],template_name)
			
			subject      = Helper.merge_tags(mailData.subject,sub_data)
			m_data          = {
				'mail_content'        : mailData.mail_content,
				'user_full_name'	  : user_full_name,
				'societyData'		  : society,
				'user_uuid'			  : user_uuid,
				'date' 				  : updated_at.strftime("%d %B %Y")
			}
			mail_content     = Helper.convert_html_for_mail_screen(m_data)
			html             = render_template('back_office/email/bo_mail_template.html',mail_content=mail_content,societyData=society)
			if send_now and int(send_now) == 1 :
				
				EMAIL.sendMail(subject,html,email,mailData,society)
				
				
			else:
				if (hour == 9 and minutes > 45) or (hour == 10 and minutes < 23):
					
					EMAIL.sendMail(subject,html,email,mailData,society)
					
				else:
					return currentTime+  "- Time not match"
		
		return 'Success for sending reminder incomplete mail'
			
	else:

		return "Incompleted data does not exist"


# @app.route('/prosec_reminder_mail',methods = ["GET", "POST"])
# @app.route('/prosec_reminder_mail/<society_id>/<society_key>',methods = ["GET", "POST"])
# def ProSecRemainderMail(society_id=None,society_key=None):
# 	society = None
# 	msg     = ""
# 	if society_id and society_key:
# 		society = Auth.checkSocietybyIdKey(society_id,society_key)

# 	if society is None: 
# 		society,msg = Auth.checkSociety()
# 	if society:
# 		society_id  = society['society_id']
# 	update_data = {}
# 	reminder_email_count = 0
# 	now 		 = datetime.now()
# 	dt_string    = now.strftime("%Y-%m-%d %H:%M:%S")
# 	hour         = now.hour
# 	minutes      = now.minute
# 	changeProSecData = MembershipMailTemplates().get_mail_template(society_id,"automail_change_prosec")
# 	reminderMailData = MembershipMailTemplates().get_mail_template(society_id,"autoreminder_prosec")
# 	if (hour == 9 and minutes > 45) or (hour == 10 and minutes < 23):
# 		pending_data  = ProSecReminderMailModel().usp_get_ps_pending_data(dt_string,society_id)
# 		if pending_data :
# 			for index,value in enumerate(pending_data):
# 				reference_id          = value['reference_id']
# 				user_id 			  = value['user_id']
# 				user_uuid 			  = value['user_uuid']
# 				reference_uuid 		  = value['reference_uuid']
# 				reference_by          = value['reference_by']
# 				reference_type        = value['type']
# 				reminder_email_count  = value['reminder_email_count']
# 				reference_prefix      = value['reference_prefix']
# 				reference_name        = value['reference_name']
# 				reference_email       = value['reference_email']
# 				user_prefix           = value['user_prefix']
# 				user_name             = value['user_name']
# 				user_email            = value['user_email']
# 				next_reminder_date    = value['next_reminder_date']

# 				reference_full_name   = reference_prefix+" "+reference_name if reference_prefix else reference_name
# 				user_full_name        = user_prefix+" "+user_name if user_prefix else user_name

# 				if reminder_email_count >= 3:
					
# 					subject       = changeProSecData.subject
# 					m_data          = {
# 						'mail_content'        : changeProSecData.mail_content,
# 						'reference_full_name' : reference_full_name,
# 						'user_full_name'	  : user_full_name,
# 						'reference_type'	  : reference_type,
# 						'societyData'         : society
# 					}
# 					reminder_email_count = reminder_email_count+ 1
# 					next_reminder_date   = next_reminder_date +timedelta(days=3)
# 					data                 = {'reminder_email_count' : reminder_email_count,'updated_at' : now,'next_reminder_date':next_reminder_date}
# 					ProSecReminderMailModel().update_reminder_data(data,reference_id) 
# 					mail_content     	 = Helper.convert_html_for_mail_screen(m_data)
# 					html                 = render_template('back_office/email/bo_mail_template.html',mail_content=mail_content)
# 					EMAIL.sendMail(subject,html,user_email,changeProSecData)

# 				else:
# 					if reminder_email_count :
# 						reminder_email_count = reminder_email_count+ 1
# 					else : 
# 						reminder_email_count = 0 +1
						
# 					if next_reminder_date :
# 						next_reminder_date = next_reminder_date +timedelta(days=3)
# 					else :
# 						next_reminder_date = now +timedelta(days=3)
# 						next_reminder_date = next_reminder_date.date()

# 					if reminder_email_count and reminder_email_count == 1 :
# 						data = {'reminder_email_count' : reminder_email_count,'reminder_one_sent_at' : now,'updated_at' : now,'next_reminder_date':next_reminder_date}
# 					elif reminder_email_count and reminder_email_count == 2 :
# 						data = {'reminder_email_count' : reminder_email_count,'reminder_two_sent_at' : now,'updated_at' : now,'next_reminder_date':next_reminder_date}
# 					else :
# 						data = {'reminder_email_count' : reminder_email_count,'reminder_three_sent_at' : now,'updated_at' : now,'next_reminder_date':next_reminder_date}
# 					ProSecReminderMailModel().update_reminder_data(data,reference_id) 
# 					ReminderProSecMail(reference_full_name,user_full_name,reminder_email_count,reference_email,reference_type,user_uuid,reference_uuid,reminderMailData)
# 			return "success"
# 		else:
# # 			print("Pending reminder data not exists.")
# 			return "Pending reminder data not exists."	
# 	else :
# # 		print(dt_string +  "- Time not match")
# 		return dt_string +  "- Time not match"			

# def ReminderProSecMail(reference_full_name,user_full_name,reminder_email_count,reference_email,reference_type,user_uuid,reference_uuid,reminderMailData):
# 	societyData     = Auth.getSociety()
# 	sub_data        = {'full_name'    : user_full_name,'society_name' : societyData['society_intial'],'reminder_email_count':str(reminder_email_count)}
# 	subject         = Helper.merge_tags(reminderMailData.subject,sub_data)
# 	m_data          = {
# 		'mail_content'        : reminderMailData.mail_content,
# 		'reference_full_name' : reference_full_name,
# 		'user_full_name'	  : user_full_name,
# 		'reference_type'	  : reference_type,
# 		'user_uuid'           : user_uuid,
# 		'reference_uuid'      : reference_uuid,
# 		'societyData'		  : societyData
# 	}
# 	# reference_email  ="priyavarthana@numerotec.com"
# 	mail_content     = Helper.convert_html_for_mail_screen(m_data)
# 	html             = render_template('back_office/email/bo_mail_template.html',mail_content=mail_content)
# 	EMAIL.sendMail(subject,html,reference_email,reminderMailData)
# 	return "success"	

# # after 3 days
# @app.route('/autoreminder_mail_after_three_days',methods = ["GET", "POST"])
# @app.route('/autoreminder_mail_after_three_days/<society_id>/<society_key>',methods = ["GET", "POST"])
# def AfterThreeDays(society_id=None,society_key=None):
# 	society = None
# 	msg     = ""
# 	if society_id and society_key:
# 		society = Auth.checkSocietybyIdKey(society_id,society_key)

# 	if society is None: 
# 		society,msg = Auth.checkSociety()
# 	if society:
# 		society_id  = society['society_id']
# 	send_now    = request.values.get('send_now',None)
# 	date 		    = datetime.now() - timedelta(days=3)
# 	currentDate     = date.strftime("%Y-%m-%d")
# 	incompletedData = Users().get_reminder_incomplete_data(society_id,currentDate)
# 	template_name   = "autoreminder_three_days"
# 	return IncompleteRemainderMail(society,incompletedData,template_name,send_now)

# #afer 7 days 
# @app.route('/autoreminder_mail_after_seven_days',methods = ["GET", "POST"])
# @app.route('/autoreminder_mail_after_seven_days/<society_id>/<society_key>',methods = ["GET", "POST"])
# def AfterSevenDays(society_id=None,society_key=None):
# 	society = None
# 	msg     = ""
# 	if society_id and society_key:
# 		society = Auth.checkSocietybyIdKey(society_id,society_key)

# 	if society is None: 
# 		society,msg = Auth.checkSociety()
# 	if society:
# 		society_id  = society['society_id']
# 	send_now  = request.values.get('send_now',None)
# 	date 		 = datetime.now() - timedelta(days=7)
# 	currentDate  = date.strftime("%Y-%m-%d")
# 	incompletedData = Users().get_reminder_incomplete_data(society_id,currentDate)
# 	template_name   = "autoreminder_seven_days"
# 	return IncompleteRemainderMail(society,incompletedData,template_name,send_now)

# def IncompleteRemainderMail(society,incompletedData,template_name,send_now):
# 	now 		 = datetime.now()
# 	currentTime  = now.strftime("%Y-%m-%d %H:%M:%S")
# 	hour         = now.hour
# 	minutes      = now.minute
# 	currentDate  = now.strftime("%Y-%m-%d")
# 	mailData     = MembershipMailTemplates().get_mail_template(society['society_id'],template_name)
# 	sub_data     = {'society_name' : society['society_intial']}
# 	subject      = Helper.merge_tags(mailData.subject,sub_data)

# 	if incompletedData:
# 		for index,value in enumerate(incompletedData):
# 			updated_at     = value['updated_at']
# 			user_prefix    = value['prefix']
# 			user_name      = value['full_name']
# 			email          = value['email']
# 			user_full_name = user_prefix+" "+user_name if user_prefix else user_name
# 			m_data          = {
# 				'mail_content'        : mailData.mail_content,
# 				'user_full_name'	  : user_full_name,
# 				'societyData'		  : society,
# 				'date' 				  : updated_at.strftime("%d %B %Y")
# 			}
# 			mail_content     = Helper.convert_html_for_mail_screen(m_data)
# 			html             = render_template('back_office/email/bo_mail_template.html',mail_content=mail_content)
			
# 	else:
# 		return "Incompleted data does not exist"

# 	if send_now and int(send_now) == 1 :
# 		EMAIL.sendMail(subject,html,email,mailData)
# 		return 'success'
# 	else:
# 		# if (hour == 10 and minutes >40 ):
# 		if (hour == 9 and minutes > 45) or (hour == 10 and minutes < 23):
# 			EMAIL.sendMail(subject,html,email,mailData)
# 			return 'success'
# 		else:
# 			return currentTime+  "- Time not match"
			
# def IncompleteRemainderMail(society,incompletedData,template_name,send_now):
# 	now 		 = datetime.now()
# 	currentTime  = now.strftime("%Y-%m-%d %H:%M:%S")
# 	hour         = now.hour
# 	minutes      = now.minute
# 	currentDate  = now.strftime("%Y-%m-%d")
# 	mailData     = MembershipMailTemplates().get_mail_template(society['society_id'],template_name)
# 	sub_data     = {'society_name' : society['society_intial']}
# 	subject      = Helper.merge_tags(mailData.subject,sub_data)

# 	if incompletedData:
		
# 		for value in incompletedData:
# 			updated_at     = value['updated_at']
# 			user_prefix    = value['prefix']
# 			user_name      = value['full_name']
# 			email          = value['email']
# 			user_full_name = user_prefix+" "+user_name if user_prefix else user_name
# 			m_data          = {
# 				'mail_content'        : mailData.mail_content,
# 				'user_full_name'	  : user_full_name,
# 				'societyData'		  : society,
# 				'date' 				  : updated_at.strftime("%d %B %Y")
# 			}
# 			mail_content     = Helper.convert_html_for_mail_screen(m_data)
# 			html             = render_template('back_office/email/bo_mail_template.html',mail_content=mail_content)
# 			if send_now and int(send_now) == 1 :
# 				# print(email)
# 				EMAIL.sendMail(subject,html,email,mailData)
				
				
# 			else:
# 				# if (hour == 10 and minutes >40 ):
# 				if (hour == 9 and minutes > 45) or (hour == 10 and minutes < 23):
# 					EMAIL.sendMail(subject,html,email,mailData)
					
# 				else:
# 					return currentTime+  "- Time not match"
# 		return 'success'
			
# 	else:

# 		return "Incompleted data does not exist"


	