from sqlalchemy import create_engine, MetaData, Table, insert, select,update,delete,text
from sqlalchemy.sql import and_, or_
from core import app
import json
from .. import engine



class UserStatusLogs():
	def __init__(self):
		try:
			self.meta               = MetaData()
			self.user_status_logs   = Table("user_status_logs", self.meta, autoload_with=engine)
		   
		except Exception as e:
			print(e)

	def insert_status(self,data):
		with engine.connect() as conn:
			result = conn.execute(self.user_status_logs.insert(), data)
			conn.commit()
			conn.close()
			return result

	def insert_status_remarks(self,datas):
		with engine.connect() as conn:
			result = conn.execute(self.user_status_logs.insert(), datas)
			conn.commit()
			conn.close()
			return result

	def get_remarks(self,user_id,status_id):
		with engine.connect() as conn:
			stmt = text("select remarks from user_status_logs where  user_id=:user_id and status_id= :status_id order by user_status_log_id desc limit 1;")
			results = conn.execute(stmt.bindparams(user_id=user_id,status_id=status_id))
			results=  results.first()
			conn.close()
			if results:
				return dict(results._mapping)
			else:
				return None
